#include-once

; Copied from AutoItObject.au3 by
; the AutoItObject team / Prog@ndy.
Func CLSIDFromString($sString)
  Local $tCLSID = DllStructCreate("dword;word;word;byte[8]")
  Local $aRet = DllCall($dllOle32, "long", "CLSIDFromString", "wstr", $sString, "ptr", DllStructGetPtr($tCLSID))
  If @error Then Return SetError(1, @error, 0)
  If $aRet[0] <> 0 Then Return SetError(2, $aRet[0], 0)
  Return $tCLSID
EndFunc

Func SHGetSpecialFolderLocation( $nFolder, ByRef $pidl )
  Local $aRet = DllCall( $dllShell32, "uint", "SHGetSpecialFolderLocation", "hwnd", 0, "int", $nFolder, "ptr*", 0 )
  If @error Then Return SetError(1, 0, 0)
  $pidl = $aRet[3]
  Return $aRet[0]
EndFunc

Func SHGetDesktopFolder( ByRef $pIShellFolder )
  Local $aRet = DllCall( $dllShell32, "uint", "SHGetDesktopFolder", "ptr*", 0 )
  If @error Then Return SetError(1, 0, 0)
  $pIShellFolder = $aRet[1]
  Return $aRet[0]
EndFunc

Func ILCreateFromPath($sPath)
  Local $aRet = DllCall($dllShell32, "ptr", "ILCreateFromPathW", "wstr", $sPath)
  If @error Then Return SetError(1, 0, 0)
  Return $aRet[0]
EndFunc

Func SHBindToParent( $pidl, $riid, ByRef $pIShellFolder, ByRef $pidlRel )
  Local $aRet = DllCall($dllShell32, "long", "SHBindToParent", "ptr", $pidl, "ptr", $riid, "ptr*", 0, "ptr*", 0)
  If @error Then Return SetError(1, 0, 0)
  $pIShellFolder = $aRet[3]
  $pidlRel = $aRet[4]
  Return $aRet[0]
EndFunc

Func StrRetToBuf( $pSTRRET, $pidl, ByRef $sBuf, $iBuf = 512 )
  Local $aRet = DllCall( $dllShlwapi, "long", "StrRetToBufW", "ptr", $pSTRRET, "ptr", $pidl, "wstr", $sBuf, "uint", $iBuf )
  If @error Then Return SetError(1, 0, 0)
  $sBuf = $aRet[3]
  Return $aRet[0]
EndFunc

Func CoTaskMemFree($pMem)
  Local $aRet = DllCall($dllOle32, "none", "CoTaskMemFree", "ptr", $pMem)
  If @error Then Return SetError(1, 0, 0)
EndFunc

Func CloseDlls()
  DllClose( $dllOle32 )
  DllClose( $dllShell32 )
  DllClose( $dllShlwapi )
EndFunc
